=== python/requirements.txt ===
# pytest 3.3 dropped support for python 2.6.
#
# See https://docs.pytest.org/en/latest/changelog.html#id164 for more details.
pytest >=2.8,<3.3

# pytest-timeout 1.2.1 dropped support for python 2.6.
#
# See https://pypi.org/project/pytest-timeout/#id5 for more details.
pytest-timeout >=1.1.0,<1.2.1

cython ==0.26.1
six
unittest2
pytz

# This is a dependency of pytest, but if we don't list it here, python 2.6
# virtualenvs will fail in build_ext with this exception:
#
#   pkg_resources.DistributionNotFound: The 'setuptools_scm>=1.15.0' distribution was not found and is required by the application
#
# See https://github.com/pypa/setuptools_scm/issues/209 for more details.
setuptools_scm
