=== debian/rules ===
#!/usr/bin/make -f
export COMPONENT_HASH=09cea83ce09c429de2c5c9776908db0000857495
 KUDU_VERSION=1.10.0+cdh6.3.2
 KUDU_PATCHED_VERSION=1.10.0-cdh6.3.2
 KUDU_BASE_VERSION=1.10.0
 KUDU_RELEASE=1605554
 CDH_CUSTOMER_PATCH=p0
 CDH_PARCEL_CUSTOM_VERSION=1.10.0+cdh6.3.2-1605554.bionic
#
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# -*- makefile -*-

# Comment this out to turn off verbose mode.
export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

EMPTY :=
SPACE := $(EMPTY) $(EMPTY)
DEFAULT_START := 2 3 4 5
DEFAULT_STOP := 0 1 6
CHKCONFIG_LEVELS := $(subst $(SPACE),,$(DEFAULT_START))
SEQ_NUMBERS := 92 8

%:
	dh $@

override_dh_auto_build:
	bash -x debian/do-component-build

override_dh_auto_install:
	bash -x debian/install_kudu.sh \
	  --build-dir=${PWD} \
	  --source-dir=debian/ \
	  --prefix=${PWD}/debian/tmp
	install -d -m 0755 debian/tmp/etc/init.d
	install -m 0755 debian/kudu-master.init debian/tmp/etc/init.d/kudu-master
	install -m 0755 debian/kudu-tserver.init debian/tmp/etc/init.d/kudu-tserver
	sed -i'' \
	  -e 's/@@SEQ_NUMBERS@@/$(SEQ_NUMBERS)/' \
	  -e 's/@@CHKCONFIG_LEVELS@@/$(CHKCONFIG_LEVELS)/' \
	  -e 's/@@DEFAULT_START@@/$(DEFAULT_START)/' \
	  -e 's/@@DEFAULT_STOP@@/$(DEFAULT_STOP)/' \
	  -e 's/@@NTP_SERVICE@@/ntp/' \
	  debian/tmp/etc/init.d/kudu-master \
	  debian/tmp/etc/init.d/kudu-tserver
	#mkdir -p debian/tmp/etc/security/limits.d
	#cp debian/kudu.conf debian/tmp/etc/security/limits.d/

override_dh_auto_test:
	echo "Skipping dh_auto_test..."

override_dh_auto_clean:
	echo "Skipping dh_auto_clean..."

override_dh_auto_configure:
	echo "Skipping dh_auto_configure..."

override_dh_installinit:
	dh_installinit --onlyscripts --restart-after-upgrade --update-rcd-params="defaults $(SEQ_NUMBERS)"

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbg-package=kudu-dbg

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_builddeb:
	dh_builddeb -- -Zgzip

override_dh_strip_nondeterminism:
	# Disable dh_strip_nondeterminism to speed up the build
